(* formulas *)    						    

type world = W of int

type propVar = P of string 

type value =
  | Succ of  world * world
  | Forces of world * propVar    
  | CountW of int
  | CountPW of int
  | CountAtSets of int
  | IsOptimum of bool
  | Root of world	
      
type  model  =
  {
    count_w : int ; (* number of worlds *)
    count_pw : int ; (* number of pworlds *)
    count_atSet : int ; (* number of atSets *)
    root : world ; (* the root *)
    succRel : (world * world) list ;  (* the successor relation *)
    forcing :   ( world * (propVar list) ) list   ;
    is_optimum : bool ;
  }  
